function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import PropTypes from 'prop-types';
import { noop } from '../../../common/helpers';
import { PaginationRow, PAGINATION_VIEW_TYPES } from '../index';
export class MockPaginationRow extends React.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "state", {
      pagination: {
        page: 1,
        perPage: 6,
        perPageOptions: [6, 10, 15, 25, 50]
      }
    });

    _defineProperty(this, "onPageInput", e => {
      const newPaginationState = Object.assign({}, this.state.pagination);
      newPaginationState.page = e.target.value;
      this.setState({
        pagination: newPaginationState
      });
    });

    _defineProperty(this, "onPerPageSelect", (eventKey, e) => {
      const newPaginationState = Object.assign({}, this.state.pagination);
      newPaginationState.perPage = eventKey;
      this.setState({
        pagination: newPaginationState
      });
    });
  }

  render() {
    const {
      viewType,
      pageInputValue,
      amountOfPages,
      pageSizeDropUp,
      itemCount,
      itemsStart,
      itemsEnd,
      onFirstPage,
      onPreviousPage,
      onNextPage,
      onLastPage
    } = this.props;
    return React.createElement(PaginationRow, {
      viewType: viewType,
      pageInputValue: pageInputValue,
      pagination: this.state.pagination,
      amountOfPages: amountOfPages,
      pageSizeDropUp: pageSizeDropUp,
      itemCount: itemCount,
      itemsStart: itemsStart,
      itemsEnd: itemsEnd,
      onPerPageSelect: this.onPerPageSelect,
      onFirstPage: onFirstPage,
      onPreviousPage: onPreviousPage,
      onPageInput: this.onPageInput,
      onNextPage: onNextPage,
      onLastPage: onLastPage
    });
  }

}
MockPaginationRow.propTypes = {
  viewType: PropTypes.oneOf(PAGINATION_VIEW_TYPES).isRequired,
  pageInputValue: PropTypes.number.isRequired,
  amountOfPages: PropTypes.number.isRequired,
  pageSizeDropUp: PropTypes.bool,
  itemCount: PropTypes.number.isRequired,
  itemsStart: PropTypes.number.isRequired,
  itemsEnd: PropTypes.number.isRequired,
  onFirstPage: PropTypes.func,
  onPreviousPage: PropTypes.func,
  onNextPage: PropTypes.func,
  onLastPage: PropTypes.func
};
MockPaginationRow.defaultProps = {
  pageSizeDropUp: true,
  onFirstPage: noop,
  onPreviousPage: noop,
  onNextPage: noop,
  onLastPage: noop
};
export const mockPaginationSource = `
import React from 'react';
import PropTypes from 'prop-types';
import { noop } from '../../../common/helpers';
import { PaginationRow, PAGINATION_VIEW_TYPES } from '../index';

export class MockPaginationRow extends React.Component {
    state = {
      pagination: {
        page: 1,
        perPage: 6,
        perPageOptions: [6, 10, 15, 25, 50]
      }
    };

  onPageInput = e => {
    const newPaginationState = Object.assign({}, this.state.pagination);
    newPaginationState.page = e.target.value;
    this.setState({ pagination: newPaginationState });
  }
  onPerPageSelect = (eventKey, e) => {
    const newPaginationState = Object.assign({}, this.state.pagination);
    newPaginationState.perPage = eventKey;
    this.setState({ pagination: newPaginationState });
  }
  render() {
    const {
      viewType,
      pageInputValue,
      amountOfPages,
      pageSizeDropUp,
      itemCount,
      itemsStart,
      itemsEnd,
      onFirstPage,
      onPreviousPage,
      onNextPage,
      onLastPage
    } = this.props;

    return (
      <PaginationRow
        viewType={viewType}
        pageInputValue={pageInputValue}
        pagination={this.state.pagination}
        amountOfPages={amountOfPages}
        pageSizeDropUp={pageSizeDropUp}
        itemCount={itemCount}
        itemsStart={itemsStart}
        itemsEnd={itemsEnd}
        onPerPageSelect={this.onPerPageSelect}
        onFirstPage={onFirstPage}
        onPreviousPage={onPreviousPage}
        onPageInput={this.onPageInput}
        onNextPage={onNextPage}
        onLastPage={onLastPage}
      />
    );
  }
}
MockPaginationRow.propTypes = {
  viewType: PropTypes.oneOf(PAGINATION_VIEW_TYPES).isRequired,
  pageInputValue: PropTypes.number.isRequired,
  amountOfPages: PropTypes.number.isRequired,
  pageSizeDropUp: PropTypes.bool,
  itemCount: PropTypes.number.isRequired,
  itemsStart: PropTypes.number.isRequired,
  itemsEnd: PropTypes.number.isRequired,
  onFirstPage: PropTypes.func,
  onPreviousPage: PropTypes.func,
  onNextPage: PropTypes.func,
  onLastPage: PropTypes.func
};
MockPaginationRow.defaultProps = {
  pageSizeDropUp: true,
  onFirstPage: noop,
  onPreviousPage: noop,
  onNextPage: noop,
  onLastPage: noop
};
`;